# coding: utf-8

"""
    NHL API

    Documenting the publicly accessible portions of the NHL API.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Conference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'float',
        'name': 'str',
        'link': 'str',
        'abbreviation': 'str',
        'short_name': 'str',
        'active': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'link': 'link',
        'abbreviation': 'abbreviation',
        'short_name': 'shortName',
        'active': 'active'
    }

    def __init__(self, id=None, name=None, link=None, abbreviation=None, short_name=None, active=None):  # noqa: E501
        """Conference - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._link = None
        self._abbreviation = None
        self._short_name = None
        self._active = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if link is not None:
            self.link = link
        if abbreviation is not None:
            self.abbreviation = abbreviation
        if short_name is not None:
            self.short_name = short_name
        if active is not None:
            self.active = active

    @property
    def id(self):
        """Gets the id of this Conference.  # noqa: E501


        :return: The id of this Conference.  # noqa: E501
        :rtype: float
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Conference.


        :param id: The id of this Conference.  # noqa: E501
        :type: float
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this Conference.  # noqa: E501


        :return: The name of this Conference.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Conference.


        :param name: The name of this Conference.  # noqa: E501
        :type: str
        """
        allowed_values = ["Eastern", "Western", "World Cup of Hockey"]  # noqa: E501
        if name not in allowed_values:
            raise ValueError(
                "Invalid value for `name` ({0}), must be one of {1}"  # noqa: E501
                .format(name, allowed_values)
            )

        self._name = name

    @property
    def link(self):
        """Gets the link of this Conference.  # noqa: E501


        :return: The link of this Conference.  # noqa: E501
        :rtype: str
        """
        return self._link

    @link.setter
    def link(self, link):
        """Sets the link of this Conference.


        :param link: The link of this Conference.  # noqa: E501
        :type: str
        """

        self._link = link

    @property
    def abbreviation(self):
        """Gets the abbreviation of this Conference.  # noqa: E501


        :return: The abbreviation of this Conference.  # noqa: E501
        :rtype: str
        """
        return self._abbreviation

    @abbreviation.setter
    def abbreviation(self, abbreviation):
        """Sets the abbreviation of this Conference.


        :param abbreviation: The abbreviation of this Conference.  # noqa: E501
        :type: str
        """
        allowed_values = ["E", "W", "WCH"]  # noqa: E501
        if abbreviation not in allowed_values:
            raise ValueError(
                "Invalid value for `abbreviation` ({0}), must be one of {1}"  # noqa: E501
                .format(abbreviation, allowed_values)
            )

        self._abbreviation = abbreviation

    @property
    def short_name(self):
        """Gets the short_name of this Conference.  # noqa: E501


        :return: The short_name of this Conference.  # noqa: E501
        :rtype: str
        """
        return self._short_name

    @short_name.setter
    def short_name(self, short_name):
        """Sets the short_name of this Conference.


        :param short_name: The short_name of this Conference.  # noqa: E501
        :type: str
        """
        allowed_values = ["East", "West", "WCup"]  # noqa: E501
        if short_name not in allowed_values:
            raise ValueError(
                "Invalid value for `short_name` ({0}), must be one of {1}"  # noqa: E501
                .format(short_name, allowed_values)
            )

        self._short_name = short_name

    @property
    def active(self):
        """Gets the active of this Conference.  # noqa: E501


        :return: The active of this Conference.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this Conference.


        :param active: The active of this Conference.  # noqa: E501
        :type: bool
        """

        self._active = active

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Conference, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Conference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
